Subject: [Add] I-D Action: draft-ietf-add-dnr-06.txt

From: [email-masked]
Date: Tue, 22 Mar 2022 04:44:36 -0700

A New Internet-Draft is available from the on-line Internet-Drafts directories.
This draft is a work item of the Adaptive DNS Discovery WG of the IETF.

        Title           : DHCP and Router Advertisement Options for the Discovery of Network-designated Resolvers (DNR)
        Authors         : Mohamed Boucadair
                          Tirumaleswar Reddy
                          Dan Wing
                          Neil Cook
                          Tommy Jensen
	Filename        : draft-ietf-add-dnr-06.txt
	Pages           : 21
	Date            : 2022-03-22

Abstract:
   The document specifies new DHCP and IPv6 Router Advertisement options
   to discover encrypted DNS servers (e.g., DNS-over-HTTPS, DNS-over-
   TLS, DNS-over-QUIC).  Particularly, it allows to learn an
   authentication domain name together with a list of IP addresses and a
   set of service parameters to reach such encrypted DNS servers.

The IETF datatracker status page for this draft is:
https://datatracker.ietf.org/doc/draft-ietf-add-dnr/

There is also an htmlized version available at:
https://datatracker.ietf.org/doc/html/draft-ietf-add-dnr-06

A diff from the previous version is available at:
https://www.ietf.org/rfcdiff?url2=draft-ietf-add-dnr-06

Internet-Drafts are also available by rsync at rsync.ietf.org::internet-drafts

---

From: Ben Schwartz <[email-masked]>
Date: Tue, 22 Mar 2022 08:16:50 -0400

As I noted in my previous review, this draft is in violation of the IPv6 RA
forming requirements: (https://www.rfc-editor.org/rfc/rfc4861#section-9):

   Options in Neighbor Discovery packets can appear in any order;
   receivers MUST be prepared to process them independently of their
   order.

By omitting the SvcPriority from the IPv6 RA option, this syntax becomes
order-reliant, which is not allowed.  (My proposed syntax revision would
avoid this problem.)

I also note that this draft now says

   AliasMode (Section 2.4.2 of [I-D.ietf-dnsop-svcb-https]) is not
   supported because such a mode will trigger additional Do53 queries
   while the data can be supplied directly by DHCP servers.

I don't think we should impose this restriction.  As I noted in my previous
review, it is easy to identify deployments where additional Do53 queries
would be highly preferable, instead of trying to distribute all of this
information via DHCP.  Do53 followup seems straightforward, since it is
exactly name-based DDR and is likely to be implemented in the same
codebase, but it could be made optional if this is a concern.

On Tue, Mar 22, 2022 at 7:44 AM <[email-masked]> wrote:

>         Title           : DHCP and Router Advertisement Options for the
> Discovery of Network-designated Resolvers (DNR)
> --
> Add mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/add
>

---

From: tirumal reddy <[email-masked]>
Date: Wed, 23 Mar 2022 14:35:39 +0530

Hi Ben,

Please see inline

On Tue, 22 Mar 2022 at 17:47, Ben Schwartz <bemasc=
[email-masked]> wrote:

> As I noted in my previous review, this draft is in violation of the IPv6
> RA forming requirements: (https://www.rfc-editor.org/rfc/rfc4861#section-9
> ):
>

> order-reliant, which is not allowed.  (My proposed syntax revision would

Our understanng is https://datatracker.ietf.org/doc/html/rfc8106 allows
ordering of DNS information without an explicit preference field. We sent
an mail to 6man WG to clarify whether our interpretation of RFC8106 is
correct or not (please see
https://mailarchive.ietf.org/arch/msg/ipv6/qeSwxWBoPTOs0fzyaSBzUC2g-sc/).

> I don't think we should impose this restriction.  As I noted in my
> previous review, it is easy to identify deployments where additional Do53
> queries would be highly preferable, instead of trying to distribute all of
> this information via DHCP.  Do53 followup seems straightforward, since it
> is exactly name-based DDR and is likely to be implemented in the same

We intended to avoid the Do53 look-up to avoid the possibility of an
external attack, additional lookup and relying on unencrypted DNS for
bootstrapping. The same reasons for adding IP addresses to the DHCP option.

However, I see your point that a deployment may want to move the complexity
to the client. We can update the draft to replace "MUST NOT" with "SHOULD
NOT" and add the reason for allowing AliasMode.

Cheers,
-Tiru

---

From: Ben Schwartz <[email-masked]>
Date: Wed, 23 Mar 2022 12:36:27 -0400

On Wed, Mar 23, 2022 at 5:06 AM tirumal reddy <[email-masked]> wrote:

>> RA forming requirements: (
>> https://www.rfc-editor.org/rfc/rfc4861#section-9):
>>

Thanks.  I've sent a followup mentioning RFC 4861.

> bootstrapping. The same reasons for adding IP addresses to the DHCP option.

Yes, I think it's reasonable to prefer ServiceMode and specified IP
addresses.

> NOT" and add the reason for allowing AliasMode.

I'm not sure "SHOULD NOT" is appropriate (as I said, there are cases where
it is likely preferable).  Perhaps "SHOULD use ServiceMode if possible".
Regardless, note that this requires* including SvcPriority in the IPv6
Neighbor Discovery DNR Option.

*Unless you want to diverge further from the SVCB specification and do
something Very Clever.

---

From: <[email-masked]>
Date: Wed, 23 Mar 2022 16:42:05 +0000

Hi Ben,

I think "SHOULD use ServiceMode” would be just OK.

Cheers,
Med

De : Add <[email-masked]> De la part de Ben Schwartz
Envoyé : mercredi 23 mars 2022 17:36
À : tirumal reddy <[email-masked]>
Cc : ADD Mailing list <[email-masked]>
Objet : Re: [Add] I-D Action: draft-ietf-add-dnr-06.txt

On Wed, Mar 23, 2022 at 5:06 AM tirumal reddy <[email-masked]<mailto:[email-masked]>> wrote:
Hi Ben,

Please see inline

On Tue, 22 Mar 2022 at 17:47, Ben Schwartz <bemasc=[email-masked]<mailto:[email-masked]>> wrote:
As I noted in my previous review, this draft is in violation of the IPv6 RA forming requirements: (https://www.rfc-editor.org/rfc/rfc4861#section-9):

By omitting the SvcPriority from the IPv6 RA option, this syntax becomes order-reliant, which is not allowed.  (My proposed syntax revision would avoid this problem.)

Our understanng is https://datatracker.ietf.org/doc/html/rfc8106 allows ordering of DNS information without an explicit preference field. We sent an mail to 6man WG to clarify whether our interpretation of RFC8106 is correct or not (please see https://mailarchive.ietf.org/arch/msg/ipv6/qeSwxWBoPTOs0fzyaSBzUC2g-sc/).

I don't think we should impose this restriction.  As I noted in my previous review, it is easy to identify deployments where additional Do53 queries would be highly preferable, instead of trying to distribute all of this information via DHCP.  Do53 followup seems straightforward, since it is exactly name-based DDR and is likely to be implemented in the same codebase, but it could be made optional if this is a concern.

We intended to avoid the Do53 look-up to avoid the possibility of an external attack, additional lookup and relying on unencrypted DNS for bootstrapping. The same reasons for adding IP addresses to the DHCP option.

Yes, I think it's reasonable to prefer ServiceMode and specified IP addresses.

However, I see your point that a deployment may want to move the complexity to the client. We can update the draft to replace "MUST NOT" with "SHOULD NOT" and add the reason for allowing AliasMode.

I'm not sure "SHOULD NOT" is appropriate (as I said, there are cases where it is likely preferable).  Perhaps "SHOULD use ServiceMode if possible".  Regardless, note that this requires* including SvcPriority in the IPv6 Neighbor Discovery DNR Option.

*Unless you want to diverge further from the SVCB specification and do something Very Clever.

_________________________________________________________________________________________________________________________

Ce message et ses pieces jointes peuvent contenir des informations confidentielles ou privilegiees et ne doivent donc
pas etre diffuses, exploites ou copies sans autorisation. Si vous avez recu ce message par erreur, veuillez le signaler
a l'expediteur et le detruire ainsi que les pieces jointes. Les messages electroniques etant susceptibles d'alteration,
Orange decline toute responsabilite si ce message a ete altere, deforme ou falsifie. Merci.

This message and its attachments may contain confidential or privileged information that may be protected by law;
they should not be distributed, used or copied without authorisation.
If you have received this email in error, please notify the sender and delete this message and its attachments.
As emails may be altered, Orange is not liable for messages that have been modified, changed or falsified.
Thank you.

---

From: <[email-masked]>
Date: Thu, 24 Mar 2022 12:48:41 +0000

Hi Ben, Chris, all,

FWIW, the full set of candidate changes can be seen at https://tinyurl.com/latest-dnr-changes.

We will wait for the feedback from 6man before we release a new revision.

Of course, we will updated the candidate version to reflect feedback.

Cheers,
Med

De : Add <[email-masked]> De la part de [email-masked]
Envoyé : mercredi 23 mars 2022 17:42
À : Ben Schwartz <bemasc=[email-masked]>; tirumal reddy <[email-masked]>
Cc : ADD Mailing list <[email-masked]>
Objet : Re: [Add] I-D Action: draft-ietf-add-dnr-06.txt

Hi Ben,

Cheers,
Med

De : Add <[email-masked]<mailto:[email-masked]>> De la part de Ben Schwartz
Envoyé : mercredi 23 mars 2022 17:36
À : tirumal reddy <[email-masked]<mailto:[email-masked]>>
Cc : ADD Mailing list <[email-masked]<mailto:[email-masked]>>
Objet : Re: [Add] I-D Action: draft-ietf-add-dnr-06.txt

Please see inline

Thank you.